# AddWatermark

The **AddWatermark** function loads a single-page PDF and superimposes that page onto one or more pages in the input document.

***

## Properties <a href="#properties" id="properties"></a>

**Input**

The following properties specify the PDF document to be loaded and modified by the operation:

#### File path <a href="#file-path" id="file-path"></a>

Path to the PDF file.

#### Authentication type <a href="#authentication-type" id="authentication-type"></a>

PDF files can be protected using a password or a certificate. This field indicates which type of authentication to attempt when loading the PDF.

1. **None**\
   The document is unprotected and can be opened immediately.
2. **Password**\
   The document is protected by a password.
3. **Certificate**\
   The document is protected by a certificate.

**Password:**

Only displayed when **Authentication type** is 'Password'.

**Password required** to access the PDF file.

{% hint style="info" %}

> **Note:**\
> All passwords entered into this function's properties will be visible in plain text in the Linx solution file and in the compiled .NET assembly.
> {% endhint %}

#### **Certificate:**

Only displayed when **Authentication type** is 'Certificate'.

**Certificate source**:\
Source to load the certificate from:

1. **File** - Load a certificate from a .pfx file.
2. **Store** - Load a certificate from the Windows certificate store.

#### **File**

Displayed when **Certificate source** is 'File'.

**Certificate file path**:\
Path to a .pfx file containing a certificate.

**Certificate file password**:\
Password needed to open the certificate file.

#### **Store:**

Displayed when **Certificate source** is 'Store'.

**Certificate**:\
Certificate in the Windows keystore.

{% hint style="info" %}

> **Note:**\
> Certificate protected files are not supported by the "Fill form", "Sign", "Add watermark," and "Concatenate" operations. If you need to use the operations on a certificate-protected document, first remove the certificate protection using the "Change protection" operation. The certificate must include the private key in order to be able to load the document.
> {% endhint %}

***

#### **Output**

The following properties specify options for saving the PDF document after it has been modified.

**File path**

Path to the PDF file to write to.

***

#### **Watermark**

**File path**

The path to a single-page PDF document to use as the watermark.

#### Authentication type <a href="#watermark-authentication-type" id="watermark-authentication-type"></a>

Authentication type required to open the PDF file.

1. **None**\
   The document is unprotected and can be opened immediately.
2. **Password**\
   The document is protected by a password.
3. **Certificate**\
   The document is protected by a certificate.

#### **Password:**

Only displayed when **Authentication type** is 'Password'.

**Password required** to access the PDF file.

#### **Certificate:**

Only displayed when **Authentication type** is 'Certificate'.

**Certificate source**:\
Source to load the certificate from:

1. **File** - Load a certificate from a .pfx file.
2. **Store** - Load a certificate from the Windows certificate store.

**Certificate file path**:\
Path to a .pfx file containing a certificate.

**Certificate file password**:\
Password needed to open the certificate file.

***

#### Misc <a href="#misc" id="misc"></a>

**Pages**

The pages to add the watermark to. A dash can be used to specify a range of pages, and multiple ranges can be specified if they are separated by a comma. For example, "1-3, 5" will select pages 1, 2, 3, and 5.

Leave this blank to add the watermark to all pages.

**Position**

Options:

1. **Above original**\
   Draws the watermark above the original document contents.
2. **Below original**\
   Draws the watermark below the original document contents.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.linx.software/reference/plugins/pdf/content/addwatermark.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
